#include <ctype.h>
#include "parser.h"



/* a little FSM to parse our little protocol */

typedef enum States {
    COMMAND,			/* looking for command */
    ARG,			/* looking for arg */
    LF,				/* looking for lf */
    ERROR			/* error; gobble rest of line */
} state;

/* this function is a big mess
   it implements a FSM to parse the cookie protocol

   it's also a huge overreliance on static variables */

void parse_line(char *buf, char cnt)
{
    static state s = COMMAND;
    int c = 0;

    static char cmd[MAXLINE];	/* command state */
    static int cpos = 0;

    static char arg[MAXLINE];	/* argument state */
    static int apos = 0;

    static int epos = 0;	/* error state */
    static char *errmsg;

    while (c < cnt) {
	switch (s) {
	case COMMAND:
	    if (cpos == 0) {
		if (buf[c] == ' ') {
		    s = ERROR;
		    errmsg = "NO Null command";
		} else {
		    cmd[cpos++] = buf[c++];
		}
	    } else { /* already have some command */
		if (!isspace(buf[c])) {
		    cmd[cpos++] = buf[c++];
		    if (cpos == MAXLINE - 1) {
			s = ERROR;
			errmsg = "NO Command too long";
			cpos = 0;
		    }
		} else {
		    /* finished the command */
		    cmd[cpos] = '\0';
		    cpos = 0;
		    arg[0] = '\0';
		    if (buf[c] == ' ') {
			s = ARG;
			c++;
		    } else if (buf[c] == '\r') {
			s = LF;
			c++;
		    } else {
			s = ERROR;
			errmsg = "NO Invalid whitespace";
		    }
		}
	    }			
	    break;
	case ARG:
	    if ((apos == 0) && ((buf[c] == ' ') || (buf[c] == '\r') ||
		                (buf[c] == '\n'))) {
		s = ERROR;
		errmsg = "NO Missing argument";
	    } else { /* already have some argument */
		if (buf[c] == '\r') {
		    arg[apos] = '\0';
		    apos = 0;
		    s = LF;
		    c++;
		} else {
		    arg[apos++] = buf[c++];
		    if (apos == MAXLINE - 1) {
			s = ERROR;
			errmsg = "NO Arguments too long";
			apos = 0;
			arg[0] = '\0';
		    }
		}
	    }
	    break;
	case LF:
	    if (buf[c++] != '\n') {
		s = ERROR;
		errmsg = "NO Invalid whitespace";
	    } else if (!strcasecmp(cmd, "NOOP")) {
	    } else if (!strcasecmp(cmd, "QUIT")) {
	    } else if (!strcasecmp(cmd, "FEED")) {
	    } else if (!strcasecmp(cmd, "HELLO")) {
	    } else {
		/* print error --- unrecognized command */

	    }
	    s = COMMAND;
	    break;
	case ERROR:
	    /* gobble until we see CRLF */
	    if (epos == 0) {
		if (buf[c++] == '\r')
		    epos = 1;
	    } else if (epos == 1) {
		if (buf[c++] == '\n') {
		    /* print error; done gobbling */

		    /* reset to COMMAND state */
		    epos = 0;
		    s = COMMAND;
		} else {
		    /* keep gobbling */
		    epos = 0;
		}
	    }
	    break;
	}
    }
}
